﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Drawing.Drawing2D;  // für Grafik


namespace Grafik1
{
    public partial class Form1 : Form
    {
        int nr;
        public Form1()
        {
            InitializeComponent();
            nr=1;
        }



        private void Form1_Load(object sender, EventArgs e)
        {
            string sPath = Application.ExecutablePath;
            Text = sPath;


            panelGrafik.Dock = DockStyle.Fill;
            cbHatchStyle.Items.Clear();            
            cbHatchStyle.Items.Add("BackwardDiagonal");
            cbHatchStyle.Items.Add("Cross");
            cbHatchStyle.Items.Add("DarkDownwardDiagonal");
            cbHatchStyle.Items.Add("DarkHorizontal");
            cbHatchStyle.Items.Add("DashedVertical");
            cbHatchStyle.Items.Add("DiagonalBrick");
            cbHatchStyle.Items.Add("DiagonalCross");
            cbHatchStyle.Items.Add("DottedDiamond");
            cbHatchStyle.Items.Add("DottedGrid");
            cbHatchStyle.Items.Add("ForwardDiagonal");
            cbHatchStyle.Items.Add("Horizontal");
            cbHatchStyle.Items.Add("LargeGrid");
            cbHatchStyle.Items.Add("LightVertical");
            cbHatchStyle.Items.Add("Max");
            cbHatchStyle.Items.Add("Min");
            cbHatchStyle.Items.Add("NarrowHorizontal");
            cbHatchStyle.Items.Add("NarrowVertical");
            cbHatchStyle.Items.Add("Percent05");
            cbHatchStyle.Items.Add("Percent10");
            cbHatchStyle.Items.Add("Percent20");
            cbHatchStyle.Items.Add("Percent30");
            cbHatchStyle.Items.Add("Percent40");
            cbHatchStyle.Items.Add("Percent50");
            cbHatchStyle.Items.Add("Percent60");
            cbHatchStyle.Items.Add("Percent70");
            cbHatchStyle.Items.Add("Percent80");
            cbHatchStyle.Items.Add("Percent90");
            cbHatchStyle.Items.Add("SmallGrid");
            cbHatchStyle.Items.Add("SolidDiamond"); 
            cbHatchStyle.Items.Add("Sphere");
            cbHatchStyle.Items.Add("Trellis");
            cbHatchStyle.Items.Add("Vertical");
            cbHatchStyle.Items.Add("Wave");
            cbHatchStyle.Items.Add("Weave");
            cbHatchStyle.Items.Add("ZigZag");
            cbHatchStyle.SelectedIndex = 0;
        }

        private void BnLine_Click(object sender, EventArgs e)
        {
            nr = 1;
            this.Refresh();
        }


        private void BnCircle_Click(object sender, EventArgs e)
        {
            nr = 2;
            this.Refresh();

        }
        private void BnRectangle_Click(object sender, EventArgs e)
        {
            nr = 3;
            this.Refresh();
        }

        private void BnBrush1_Click(object sender, EventArgs e)
        {
            nr = 4;
            this.Refresh();
        }

        private void BnBrush2_Click(object sender, EventArgs e)
        {
            nr = 5;
            this.Refresh();
        }

        
        private void cbHatchStyle_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (nr == 5) this.Refresh();
        }

        private void BnBrush3_Click(object sender, EventArgs e)
        {
            nr = 6;
            this.Refresh();
        }
        private void BnBrush4_Click(object sender, EventArgs e)
        {
            nr = 7;
            this.Refresh();
        }

        private void BnDrawString1_Click(object sender, EventArgs e)
        {
            nr = 8;
            this.Refresh();
            //BnDrawString1
        }
        private void BnDrawString2_Click(object sender, EventArgs e)
        {
            nr = 9;
            this.Refresh();

        }
        private void BnDrawString3_Click(object sender, EventArgs e)
        {
            nr = 10;
            this.Refresh();
        }
        private void BnImage_Click(object sender, EventArgs e)
        {
            nr = 11;
            this.Refresh();
        }

        private void BnBezier_Click(object sender, EventArgs e)
        {
            nr = 12;
            this.Refresh();
        }
        private void panelGrafik_Paint(object sender, PaintEventArgs e)
        {            
            Graphics g = e.Graphics;
            Pen pen1;
            Pen pen2;
            Rectangle rect;
            Point p1;
            Point p2;
            Brush mybrush;
            Font drawFont1;
            Font drawFont2;
            switch (nr)
            {
                case 1: pen1 = new Pen(Color.Blue, 6);
                        pen1.DashStyle = System.Drawing.Drawing2D.DashStyle.DashDot;
                        g.DrawLine(pen1, 10, 0, 300, 400);
                        pen1.Dispose();
                        break;

                case 2: pen1 = new Pen(Color.Black, 3);
                        pen2 = new Pen(Color.Red, 6);
                        pen1.DashStyle = System.Drawing.Drawing2D.DashStyle.DashDot;
                        rect = new Rectangle(10, 10, 200, 200);
                        g.DrawEllipse(pen1, rect);
                        g.DrawEllipse(pen2, 20, 20, 180, 180);  // width, height
                        pen1.Dispose();
                        pen2.Dispose(); break;

                case 3: pen1 = new Pen(Color.Black, 3);
                        pen2 = new Pen(Color.Red, 6);
                        pen2.DashStyle = System.Drawing.Drawing2D.DashStyle.Dot;
                        rect = new Rectangle(10, 10, 200, 200);                      
                        g.DrawRectangle(pen1, rect);
                        g.DrawRectangle(pen2, 20, 20, 180, 180);  // width, height
                        pen1.Dispose();
                        pen2.Dispose();
                        break;

                case 4: SolidBrush drawBrush = new SolidBrush(Color.Black);
                        g.FillEllipse(drawBrush, 152, 112, 150, 80);
                        drawBrush.Dispose();
                        break;

                case 5: Brush mybrush1 = new HatchBrush( HatchStyle.DiagonalCross, Color.Green);
                        g.FillEllipse(mybrush1, 152, 112, 150, 80);
                        Brush mybrush2 = new HatchBrush(HatchStyle.ZigZag, Color.Red);
                        g.FillEllipse(mybrush2, 10, 11, 120, 80);

                        HatchStyle hstylecomboBox = getHatchStyle();
                        Brush mybrush3 = new HatchBrush(hstylecomboBox, Color.Blue);
                        g.FillEllipse(mybrush3, 10, 120, 140, 180);
                        break;

                case 6: p1 = new Point(0, 0);
                        p2 = new Point(200, 100);	// Größe des Schemas
                        mybrush = new LinearGradientBrush(
                            p1,
                            p2,
                            Color.Red,
                            Color.Blue
                        );
                        g.FillEllipse(mybrush, 50, 50, 300, 200);
                        mybrush.Dispose();
                        break;
                case 7: p1 = new Point(0, 0);
                        p2 = new Point(400, 0);	// Größe des Schemas
                        mybrush = new LinearGradientBrush(
                            p1,
                            p2,
                            Color.FromArgb(255,255,0),
                            Color.Blue
                        );
                        g.FillEllipse(mybrush, 50, 50, 300, 200);
                        mybrush.Dispose();
                        break;

                case 8: drawFont1 = new Font("Arial", 16);
                        drawFont2 = new Font("Courier New", 16, 
	                                FontStyle.Bold | FontStyle.Underline );
                        drawBrush = new SolidBrush(Color.Black);
                        PointF drawPoint = new PointF(50.0F, 55.0F);
                        g.DrawString("Hier ist ein Text", drawFont1, drawBrush, drawPoint);
                        g.DrawString("Hier ist zweiter Text", drawFont2, drawBrush, new PointF(50.0F, 85.0F) );
                        drawBrush.Dispose();
                        drawFont1.Dispose();
                        drawFont2.Dispose();
                        break;
                case 9: // Create string to draw.
                        String drawString = "Sample Text";

                        // Create font and brush.
                        drawFont1 = new Font("Arial", 16);
                        drawBrush = new SolidBrush(Color.Black);

                        // Create point for upper-left corner of drawing.
                        drawPoint = new PointF(150.0F, 50.0F);

                        // Set format of string.
                        StringFormat drawFormat = new StringFormat();
                        drawFormat.FormatFlags = StringFormatFlags.DirectionVertical;
                        

                        // Draw string to screen.
                        e.Graphics.DrawString(drawString, drawFont1, drawBrush, drawPoint, drawFormat);

                        break;
                case 10: p1 = new Point(0, 0);
                        p2 = new Point(200, 100);	// Größe des Schemas
                        mybrush = new LinearGradientBrush(
                            p1,
                            p2,
                            Color.Red,
                            Color.Blue
                        );
                        drawFont1 = new Font("Arial", 44);
                        Point drawPoint1 = new Point(50, 55);
                        g.DrawString("Hier ist ein Text", drawFont1, mybrush, drawPoint1);
                        mybrush.Dispose();
                        drawFont1.Dispose();

                        break;

                case 11: pen1 = new Pen(Color.BlanchedAlmond, 6);
                        pen1.DashStyle = System.Drawing.Drawing2D.DashStyle.Dash;
                        Point point1 = new Point(50, 50); Point point2 = new Point(100, 25);
                        Point point3 = new Point(200, 5); Point point4 = new Point(250, 50);
                        Point point5 = new Point(300, 100); Point point6 = new Point(350, 200);
                        Point point7 = new Point(250, 250);
                        Point[] curvePoints = { point1, point2, point3, point4, point5, point6, point7 };

                        String sProgramm = Application.ExecutablePath;
                        int ipos=sProgramm.LastIndexOf("\\");
                        String sPath = sProgramm.Substring(0, ipos+1);
                        Image newImage = Image.FromFile(sPath+"bsp1.jpg");
                        // Punkt oben / links des Bildes
                        Point ulCorner = new Point(20, 20);
                        // Draw image to screen.
                        g.DrawImage(newImage, ulCorner);
                        g.DrawPolygon(pen1, curvePoints);
                        pen1.Dispose();
                        break;
                case 12: pen1 = new Pen(Color.Black, 3);
                        pen2 = new Pen(Color.Red, 1);
                        pen2.DashStyle = System.Drawing.Drawing2D.DashStyle.Dash;

                        // Create points for curve.
                        Point start = new Point(100, 100);
                        Point control1 = new Point(200, 10);
                        Point control2 = new Point(350, 50);
                        Point end = new Point(500, 100);

                        // Draw arc to screen.
                        g.DrawBezier(pen1, start, control1, control2, end);
                        g.DrawLine(pen2, start, control1);
                        g.DrawLine(pen2, control1, control2);
                        g.DrawLine(pen2, control2,end);

 
                        break;
            }  // switch
            g.Dispose();
        }

        HatchStyle getHatchStyle()
        {
            switch (cbHatchStyle.SelectedIndex)
            {
                case 0: return HatchStyle.BackwardDiagonal;
                case 1: return HatchStyle.Cross;
                case 2: return HatchStyle.DarkDownwardDiagonal;
                case 3: return HatchStyle.DarkHorizontal;
                case 4: return HatchStyle.DashedVertical;
                case 5: return HatchStyle.DiagonalBrick;
                case 6: return HatchStyle.DiagonalCross;
                case 7: return HatchStyle.DottedDiamond;
                case 8: return HatchStyle.DottedGrid;
                case 9: return HatchStyle.ForwardDiagonal;
                case 10: return HatchStyle.Horizontal;
                case 11: return HatchStyle.LargeGrid;
                case 12: return HatchStyle.LightVertical;
                case 13: return HatchStyle.Max;
                case 14: return HatchStyle.Min;
                case 15: return HatchStyle.NarrowHorizontal;
                case 16: return HatchStyle.NarrowVertical;
                case 17: return HatchStyle.Percent05;
                case 18: return HatchStyle.Percent10;
                case 19: return HatchStyle.Percent20;
                case 20: return HatchStyle.Percent30;
                case 21: return HatchStyle.Percent40;
                case 22: return HatchStyle.Percent50;
                case 23: return HatchStyle.Percent60;
                case 24: return HatchStyle.Percent70;
                case 25: return HatchStyle.Percent80;
                case 26: return HatchStyle.Percent90;
                case 27: return HatchStyle.SmallGrid;
                case 28: return HatchStyle.SolidDiamond;
                case 29: return HatchStyle.Sphere;
                case 30: return HatchStyle.Trellis;
                case 31: return HatchStyle.Vertical;
                case 32: return HatchStyle.Wave;
                case 33: return HatchStyle.Weave;
                case 34: return HatchStyle.ZigZag;
                default: return HatchStyle.Vertical;
            }
        }








    }
}
